Subject: Re: bug#23483: 24.5; cygwin emacs w32 doesn not ask to save files when windows shuts down

From: Eli Zaretskii <[email-masked]>
Date: Sat, 14 May 2016 10:56:42 +0300

> Cc: "[email-masked]" <[email-masked]>
> From: Ken Brown <[email-masked]>
> Date: Fri, 13 May 2016 19:12:14 -0400
> 
> > Perhaps better is to have emacs simply abort a restart / shutdown and require the user to manually close emacs.  If it doesn't behave like other windows programs (query user to save unsaved files), then we have to remember emacs is special.  You could have a parameter for whether emacs aborts a windows shutdown, default to yes, and then users and consciously shut it off if they want.
> 
> I'm not convinced that this is better.  But as an experiment, I decided 
> to see if I could make emacs do what you want by having a system 
> shutdown trigger 'save-buffers-kill-emacs' instead of 'kill-emacs'. 
> What happened was that Windows complained that emacs was preventing it 
> from shutting down, and it gave me the choice of shutting down anyway or 
> canceling the shutdown.  I chose the latter, at which point I was faced 
> with a non-responsive emacs that had to be killed.
> 
> I don't have any further ideas.

AFAIK, doing what David wants is tricky technically (because our
message pump runs in a separate thread, which cannot run Lisp), and is
IMO not important enough for us to try getting out of our way.  Like I
said, having to answer all those questions always annoys me.

Thanks.